import java.applet.*;
import java.awt.*;
 
////////////////////////////////////////////////////////////////////////////#
//  
//   File: RanGaussDist.java 
//
//      Title  : CPS606 spring98 Homework 2, Writing a Java Applet
//       Author: Haci Ali Mantar
//      Contact: hamantar@top.cis.syr.edu
//        Input: Floating point numbers
//          
//
//       Output: Real Gaussian Distribution Function.
//Description: It generates Random numbers between a range And then draw the bars 
//For that value. The last view of figure looks like Gaussian Dist Func. To See it draws close 
//it and redraw again. 
//////////////////////////////////////////////////////////////////////////////
//
//  IMPLEMENTATION
//
//////////////////////////////////////////////////////////////////////////////




public class RanGaussDist extends Applet  implements Runnable  {
  int MAX=16;
  int counter;
  RandomFlG randomFG; // It generates random number according to the definetion. 
  
 // Instance variables:
  Bar  bars[];// the figure of Gaussian dist. value 
  Thread thread;      // a thread
  Image image;        // for double buffering

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///// The value of Gaussian Dist Function between 0 and 5 increment by 0.3. All this value are real value of///
////////////////////gaoussian dist. Func. The function takes the value from this array.///////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
  double PGD [] ={0.5,0.38208,
0.27423,0.18402,0.11507,0.066804,0.035929,0.017864,0.0081,0.0034,0.0013,0.00048,0.000159,0.000048,0.0000133,0.00000339};


/////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////Initializing objects. All the object start from center.//////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////

public void initObjects() {
  counter=0;
  
  /* initialize a Bar */
  bars=new Bar[16];
  for (int i=0;i<16;i++){
    bars[i] = new Bar();
    bars[i].placeOrigin(getSize().width/2,getSize().height/2,-1); // Setting the origin of bars
  }
   
  

  image =createImage( getSize().width, getSize().height );
  //  randomFG=new RandomFlG();
  
  
}
  //////////////////////////////////////////////////////////////////////////////////////////
///////////////////////Override java.applet.Applet.init://////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

public void init () {
  initObjects();
      randomFG=new RandomFlG();

}
 
//////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////Override java.applet.Applet.stop:///////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////

 public void start() {
    if (thread == null) {
      // Reinitialize:
      initObjects();
      thread = new Thread( this );
      thread.start();
    }
  }

//////////////////////////////////////////////////////////////////////////////////////////// 
////////////////////////// Override java.applet.Applet.stop:///////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////    

public void stop() {
    if (thread != null) {
      thread.stop();
      thread = null;
    }
  }

////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////Implement java.lang.Runnable.run:////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

  public void run() {
    while(thread != null && counter<16 ) {
      repaint();  // repaint() invokes update():

      counter++;
      
      try {
        Thread.sleep(1500);
      }
      catch(InterruptedException e) {
        // Do nothing
      };
    }
  }
////////////////////////////////////////////////////////////////////////////////////////////// 
/////////////////// Override java.awt.Component.update://////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////
public void update(Graphics g) {
 
  double nv= randomFG.next();// It picks up a number from R.G 
  
  int ar= (int)(nv/0.3);// gets the correspending value of the double number to the integer for array ass.
  bars[ar].setPicked();
  bars[ar].setSize(PGD[ar],nv); //Sets the value of bars.
 
//////////////////////////////////////////////////////////////////////////////////////////  
//////////////////////// Get Off Screen Graphics Context/////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
  
  Graphics og = image.getGraphics();
  og.setColor(getBackground()); // fill background 

  og.clearRect(0,0,getSize().width,getSize().height);
  
  int rank=0;
  
  for(int i=0;i<MAX;i++){
    if (bars[i].picked()) {
      bars[i].setLocation(15*rank);// leaves the space between Bars.
      bars[i].paint(og);
      og.setColor(Color.blue);
      Font theFont = new Font ("TimesRoman",Font.PLAIN,7);	
     og.setFont(theFont); 
og.drawString(Double.toString(bars[i].getSize()),bars[i].getX(),bars[i].getY()+9);
      rank++; //Write  the number to the screen. 
  Font theFont2 = new	Font("TimesRoman",Font.PLAIN,13);
 og.setFont(theFont2);    
}

  }
 og.setColor(Color.red);
og.drawString(" THE GAUSSIAN DIST. FUNCTION VALUES,(ERF(X))",getSize().width/2-80,50);  
 og.setColor(Color.blue);
og.drawString(" TO SEE AGAIN HOW IT DRAWS CLOSE AND THEN OPEN BACK",getSize().width/2-80,80);
og.setColor(Color.blue);
og.drawLine(20,getSize().height/2,20,getSize().height/2-300);
  og.setColor(Color.red);
  for (int i=0;i<7;i++) {
 og.drawString(Double.toString(PGD[i]),25,getSize().height/2 - (int)(PGD[i]*300)); //write the number
											//correspond to each bar
  }
    paint(g);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////// This function shows the figure, gets the ready figure from background///////
////////////////////////////////////////////////////////////////////////////////////////////////  
 
public void paint(Graphics g) {
    g.drawImage(image, 0, 0, this);// get the the figure to the screen.
  }
}
 



/////////// CLASS2/////


/////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////// This class generate a rondom number between the 0-50 and it only/////////////////
///////////takes the number whose mod are 0 for 3, It can be easly modify just by cahnging/////////
//////the these two number, Also one of the feature of this class it does not generate more///////
//////than ones//////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////

 
class RandomFlG
{
  int [] selected;
  int counter;
  
 
public RandomFlG(){
 
  selected = new int[16]; // the array of number whose value are goint to be displayed. 
  counter=0;
 
}
//////////////////////////////////////////////////////////////////////////////////////
/// It marks the number has been choosen and same number will not be generate//////// 
/////////////////////////////////////again//////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
public boolean picked(double X)
  {
    for (int i=0 ; i<counter;i++){
      if (selected[i]==X)
        return true;
    }
    return false;
  }
  
//////////////////////////////////////////////////////////////////////////////////////////////////      
/////////////////Gets  a random number///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////

public  double next() {
 
  int X=1;
  while(X % 3 !=0 ||  picked(X)){
   X=(int) (Math.random()*47);// the range of 47
  }

     try {
           selected[counter]=X ;//keeps the number has been choosen.
      }
 
	catch(Exception e) {
        	System.exit(1);
              };

  counter++;
return (double)X/10.0;
}
}

//The end of the program.
